import typing as t

from ellar.core.params.params import Param, ParamTypes
from ellar.core.routing import ModuleRouter

from .decorators import (
    Controller,
    Module,
    command,
    exception_handler,
    extra_args,
    file,
    guards,
    middleware,
    on_shutdown,
    on_startup,
    openapi_info,
    render,
    serializer_filter,
    set_metadata,
    template_filter,
    template_global,
    version,
)
from .routing import (
    Body,
    Context,
    Cookie,
    File,
    Form,
    Header,
    Host,
    Http,
    Path,
    Provide,
    Query,
    Req,
    Res,
    Session,
    UploadFile,
    Ws,
    WsBody,
    delete,
    get,
    head,
    http_route,
    options,
    patch,
    post,
    put,
    trace,
    ws_route,
)

__all__ = [
    "command",
    "ModuleRouter",
    "render",
    "Module",
    "guards",
    "Param",
    "ParamTypes",
    "set_metadata",
    "Controller",
    "openapi_info",
    "version",
    "delete",
    "get",
    "head",
    "http_route",
    "options",
    "patch",
    "post",
    "put",
    "trace",
    "ws_route",
    "Body",
    "Cookie",
    "File",
    "Form",
    "Header",
    "Path",
    "Query",
    "WsBody",
    "Context",
    "Provide",
    "Req",
    "Ws",
    "middleware",
    "exception_handler",
    "serializer_filter",
    "on_shutdown",
    "on_startup",
    "template_filter",
    "template_global",
    "Res",
    "Session",
    "Host",
    "Http",
    "UploadFile",
    "file",
    "extra_args",
]


def __dir__() -> t.List[str]:
    return sorted(__all__)  # pragma: no cover
